﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private XUI As XUI

	'@@@@@  maybe should rename this as well ... same name as View  .. lblReceiptID
	Type ItemValue (lblReceiptID As String)
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
		
	'v0.1  (17/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	
	'CLV & Row Items That are edited / changed in code  
	Private clvPanel As CustomListView
	
	Private lblReceiptDate As B4XView  'can be declared as Labels if you want ... recommended cross platform views.
	Private lblRetailer As B4XView
	Private lblReceiptID As B4XView
	'..............................................................................................
	
	'Global Variables to store info pertaining to these views
	Private ReceiptDate, Retailer, ReceiptID As String
	
	'...............................................................................................
	
	Private ECReceiptSet As ResultSet
	Private lstReceiptID(1) As List
	Private lstReceiptDate(1) As List
	Private lstReceiptRetailerID(1) As List
	Private lstReceiptAmount(1) As List
	Private lstReceiptChargeStoreID(1) As List
	Private lstReceiptNotes(1) As List
	Private lstReceiptPhoto(1) As List
	Private lstReceiptClaimID(1) As List
	Private lstReceiptClaimPart(1) As List
	
	Private intRetailerID As Int
	Private strRetailerName As String
	
	Private strStoreID As Int
	Private strStoreName As String
	
	
	'@@@  note  you only have to declare views that you are going to refernce / edit/ change properties at runtime.
	'They will still be initialize when you load the layout containing the view.
	Private lblBack As Label
		
	Private strSQLQuery As String

End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	SelectReceiptList

	DateTime.DateFormat = "dd/MM/yy"
	
	Activity.LoadLayout("ECS20")
	
	lblVersion.Text = strVersion

'.....................................................................
	'probable dont need global variables for these items ... unless you are referencing the variables elswhere in ECS20 module.
	
	ReceiptDate = "22/05/20"
	Retailer = "Ebay"
	ReceiptID = "2005003"

	For x = 1 To 5
		Dim iv As ItemValue    '@@@@ refer note global variable
		iv.Initialize
		clvPanel.Add(CreateItem(ReceiptDate, Retailer, ReceiptID), ReceiptID) 
		 '@@@ Have used receiptID as return value for CLV click ... if data is from Database it is a good idea maybe to use db ID
		 'so db record can be accessed on clv click .. food for thought.
	Next
	
	'..........................................................................................................................................................................................................................
	'@@@ rough example from DB
	
	'Dim RS As ResultSet
	'Starter.SQL1.ExecQuery("Select *  .....      recommended SQL objact declared in Starter service .. up to you
	
	'Dim strReceiptDate, strRetailer, strReceiptID As String
		
	'Do While RS.NextRow
	'	strReceiptDate = RS.GetString("ReceiptDate")
	'	strRetailer = RS.GetString("Retailer")
	'	strReceiptID = RS.GetInt("ReceiptID")
	'	clvPanel.Add(CreateItem(strReceiptDate, strRetailer, strReceiptID), strReceiptID)
		
	'Loop
	'..........................................................................................................................................................................................................................

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub CreateItem(strReceiptDate As String, strRetailer As String, strReceiptID As String) As B4XView
	
	Dim p As B4XView = XUI.CreatePanel("")
	
	p.SetLayoutAnimated(0, 0, 0, 100%x, 120dip)
	p.LoadLayout("ECS20clv")
	
	lblReceiptDate.Text = strReceiptID
	lblRetailer.Text = strRetailer
	lblReceiptID.Text =strReceiptID
	
	Return p
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectReceiptList

	lstReceiptID(0).Initialize
	lstReceiptDate(0).Initialize
	lstReceiptRetailerID(0).Initialize
	lstReceiptAmount(0).Initialize
	lstReceiptChargeStoreID(0).Initialize
	lstReceiptNotes(0).Initialize
	lstReceiptPhoto(0).Initialize
	lstReceiptClaimID(0).Initialize
	lstReceiptClaimPart(0).Initialize
	
	strSQLQuery = "Select * FROM Receipt ORDER BY ReceiptID DESC"
	
	ECReceiptSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
	Do While ECReceiptSet.NextRow
		lstReceiptID(0).Add(ECReceiptSet.GetString("ReceiptID"))
		lstReceiptDate(0).Add(ECReceiptSet.GetString("ReceiptDate"))
		lstReceiptRetailerID(0).Add(ECReceiptSet.GetInt("ReceiptRetailerID"))
		lstReceiptAmount(0).Add(ECReceiptSet.GetDouble("ReceiptAmount"))
		lstReceiptChargeStoreID(0).Add(ECReceiptSet.GetString("ReceiptChargeStoreID"))
		lstReceiptNotes(0).Add(ECReceiptSet.GetString("ReceiptNotes"))
		lstReceiptPhoto(0).Add(ECReceiptSet.GetBlob("ReceiptPhoto"))
		lstReceiptClaimID(0).Add(ECReceiptSet.GetInt("ReceiptClaimID"))
		lstReceiptClaimPart(0).Add(ECReceiptSet.GetInt("ReceiptClaimPart"))
	Loop

End Sub

Sub SelectRetailerName
		
	strSQLQuery = "Select RetailerName FROM Retailer WHERE RetailerID = ?"
	
	strRetailerName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intRetailerID))
	
End Sub

Sub SelectStoreName
	
	strSQLQuery = "Select StoreName FROM Store WHERE StoreID = ?"
	
	strStoreName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strStoreID))

End Sub

'CLICK EVENTS
'============

Sub lblBack_Click
	
	Activity.Finish

End Sub
